package it.gabrieleerba.nzuntachat.Tavolozza;

import java.awt.* ;
import java.util.Vector ;
/**
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *  
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *  
 *  Copyright 2002 
 *
 * @author Gabriele Erba <nzunta@gabrile-erba.it>
 * @version 1.0
 *
 */

public class tavolozza extends java.awt.Label {
    private Image current ; 
    private boolean attivo = false ;
    private Color sfondo = Color.white ;
    private Vector list = new Vector();
    private int conto = 0 ;
    
    public tavolozza() {
    }
    
    // aggirna l'immagine
    public void paint(java.awt.Graphics graphics) {
        if (attivo) {
            graphics.drawImage(current,0,0,null);
        }      
    }
    
    // aggiunge una riga
    public void disegna(int x,int y,int z,int v,Color col) {
        tratto temp;
        Graphics g = current.getGraphics();
        temp = new tratto(x,y,z,v,col) ;
        //lista.aggiungi(temp) ;
        list.add(temp) ;
        conto++ ;
        g.setColor(col);
        g.drawLine(temp.getx0(),temp.gety0(),temp.getx1(),temp.gety1());
        this.repaint();
    }
    
    //elimina una riga
    public void eliminaul() {
        // se non ci sono righe esce
        if (conto!=0) {
           conto-- ;
           list.removeElementAt(conto) ;
           // se sono state cancellate tutte la righe falseil repaint
           if (conto!=0) {
                int n=0;
                tratto t ;
                t = (tratto) (list.elementAt(n)) ;
                current = createImage(300,300);
                Graphics g = current.getGraphics();
                g.setColor(sfondo);
                g.fillRect(0,0,300,300);
                g.setColor(t.getcol());
                g.drawLine(t.getx0(),t.gety0(),t.getx1(),t.gety1());
                n++ ;
                while (n < conto){
                    t = (tratto) (list.elementAt(n)) ;
                    g.setColor(t.getcol());
                    g.drawLine(t.getx0(),t.gety0(),t.getx1(),t.gety1());
                    n++ ;
                }
            }
            else {
                current = createImage(300,300);
                Graphics g = current.getGraphics();
                g.setColor(sfondo);
                g.fillRect(0,0,300,300);
            } 
            this.repaint();
        } 
    }
    
    // rimuove tutto
    public void svuota() {
       sfondo = Color.white ;
       list.removeAllElements() ;
       conto = 0 ;
       current = createImage(300,300);
       Graphics g = current.getGraphics();
       g.setColor(Color.white);
       g.fillRect(0,0,300,300);
       this.repaint() ;
    }
    
    // attiva la tavolozza
    public void attiva() {
        current = createImage(300,300);
	Graphics g = current.getGraphics();
	g.setColor(Color.white);
	g.fillRect(0,0,300,300);
        attivo = true ;
        }
	
    // cambia lo sfondo    
    public void sfondo(Color col) {
        sfondo = col ;
        Graphics g = current.getGraphics();
        g.setColor(col);
        g.fillRect(0,0,300,300);
        // se non ci sono righe non disegna ma chiama subito repaint
        if (conto!=0) {
            int n=0;
            tratto t ;
            t = (tratto) (list.elementAt(n)) ;
            g.setColor(t.getcol());
            g.drawLine(t.getx0(),t.gety0(),t.getx1(),t.gety1());
            n++ ;
            while (n < conto){
                t = (tratto) (list.elementAt(n)) ;
                g.setColor(t.getcol());
                g.drawLine(t.getx0(),t.gety0(),t.getx1(),t.gety1());
                n++ ;
            }
        }
        this.repaint();
    }
    
    // restituisce l'immagine
    public Image getimage() {
        return current ;
    }
}
